import java.awt.Image;
import java.io.File;
import java.net.URL;
import java.net.URLConnection;
import java.io.IOException;
import java.util.*;

import org.jdom.Element;
import org.jdom.Document;

import vlc.net.content.*;
import vlc.net.content.image.*;

/**
 *
 * @author Alberto Manuel Brando Simes
 */
public class Map implements XML {
    private File filename;
    private Image image;
    private Vector layers;

    /**
     *
     */
    public Map(Document xml) throws InvalidElementException {
	layers = new Vector();
	Element root = xml.getRootElement();
	Iterator childs = root.getChildren().iterator();
	while(childs.hasNext()) {
	    Element el = (Element)childs.next();
	    if (el.getName().equals("filename")) {
		filename = new File(el.getText());
	    } else 
		if (el.getName().equals("layer")) {
		    layers.add(new Layer(el));
		} else {
		    InvalidElementException exc = new InvalidElementException(el.getName());
		    throw exc;
		}
	}
	try {
	    Object o;
	    URLConnection c = filename.toURL().openConnection();
	    
	    String contenttype=c.getContentType();
	    System.out.println("Content type is " + contenttype);
	    
	    o = c.getContent();
	    if (o instanceof Image) {
		image = (Image)o;
	    } else {
		System.out.println("Not an image");
	    }
	    
	}
	catch (IOException e) {
	    // TODO: move this elsewhere
	    System.out.println(e.toString());
	}
	
    }

    /**
     *
     */
    public Map(File file) {
	filename = file;

	try {
	    Object o;
	    URLConnection c = filename.toURL().openConnection();

	    String contenttype=c.getContentType();
	    System.out.println("Content type is " + contenttype);

	    o = c.getContent();
	    if (o instanceof Image) {
		image = (Image)o;
	    } else {
		System.out.println("Not an image");
	    }
	    
	}
	catch (IOException e) {
	    // TODO: move this elsewhere
	    System.out.println(e.toString());
	}

	layers = new Vector();
    }

    public File getFile() {
	return this.filename;
    }

    public Image getImage() {
	return this.image;
    }

    public Vector getLayers() {
	return this.layers;
    }

    public Element toXML() {
	Element map = new Element("map");
	map.addContent(new Element("filename").addContent(filename.toString()));
	
	Enumeration elems = layers.elements();
	while (elems.hasMoreElements()) {
	    Layer l = (Layer)elems.nextElement();
	    map.addContent(l.toXML());
	}
	return map;
    }

    public void addLayer(String title, String description) {
	Layer x = new Layer(title);
	x.setDescription(description);
	layers.add(x);
    }

}
